compile.sh 6.04 KB
Newer Older
Rémi Duraffort's avatar
Rémi Duraffort committed
1 2
#! /bin/sh

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
3 4 5
# Read the Android Wiki http://wiki.videolan.org/AndroidCompile
# Setup all that stuff correctly.
# Get the latest Android SDK Platform or modify numbers in configure.sh and vlc-android/default.properties.
Rafaël Carré's avatar
Rafaël Carré committed
6

7 8
set -e

9 10 11 12
if [ -z "$ANDROID_NDK" -o -z "$ANDROID_SDK" -o -z "$ANDROID_ABI" ]; then
   echo "You must define ANDROID_NDK, ANDROID_SDK and ANDROID_ABI before starting."
   echo "They must point to your NDK and SDK directories.\n"
   echo "ANDROID_ABI should match your ABI: armeabi-v7a, armeabi or ..."
Rafaël Carré's avatar
Rafaël Carré committed
13 14
   exit 1
fi
Rafaël Carré's avatar
Rafaël Carré committed
15 16 17 18 19 20 21 22 23
# try to detect NDK version
REL=$(grep -o '^r[0-9]*.*' $ANDROID_NDK/RELEASE.TXT 2>/dev/null|cut -b2-)
case "$REL" in
    7|8)
        # NDK > v7, only gcc 4.4.3 available
        GCCVER=4.4.3
        CXXSTL=""
    ;;
    8?)
Sébastien Toque's avatar
Sébastien Toque committed
24 25
        # NDK >= v8b, both 4.4.3 and 4.6 available,
        # we use 4.4.3 because there is a regression in gcc 4.6, DECL_USER_ALIGN is not handled properly
26 27
        GCCVER=4.4.3
        CXXSTL="/4.4.3"
Rafaël Carré's avatar
Rafaël Carré committed
28 29 30 31 32 33 34 35 36
    ;;
    *)
        echo "You need the NDKv7 or later"
        exit 1
    ;;
esac

export GCCVER
export CXXSTL
Rémi Duraffort's avatar
Rémi Duraffort committed
37

38 39
# XXX : important!
cat << EOF
Edward Wang's avatar
Edward Wang committed
40
For an ARMv7-A device without NEON, you need a build without NEON:
41 42 43
$ export NO_NEON=1
For an ARMv6 device without FPU, you need a build without FPU:
$ export NO_FPU=1
Edward Wang's avatar
Edward Wang committed
44 45
For an ARMv5 device or the Android emulator, you need an ARMv5 build:
$ export NO_ARMV6=1
46 47 48

If you plan to use a release build, run 'compile.sh release'
EOF
49

Edward Wang's avatar
Edward Wang committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66
# Set up ABI variables
if [ ${ANDROID_ABI} = "x86" ] ; then
    TARGET_TUPLE="i686-android-linux"
    PATH_HOST="x86"
    HAVE_X86=1
    PLATFORM_SHORT_ARCH="x86"
elif [ ${ANDROID_ABI} = "mips" ] ; then
    TARGET_TUPLE="mipsel-linux-android"
    PATH_HOST=$TARGET_TUPLE
    HAVE_MIPS=1
    PLATFORM_SHORT_ARCH="mips"
else
    TARGET_TUPLE="arm-linux-androideabi"
    PATH_HOST=$TARGET_TUPLE
    HAVE_ARM=1
    PLATFORM_SHORT_ARCH="arm"
fi
67 68 69 70 71 72 73 74 75 76 77 78 79

if [ ${ANDROID_ABI} = "x86" ] ; then
    # x86 toolchain location changes in NDK r8b
    case "$REL" in
        8?)
            TARGET_TUPLE="i686-linux-android"
        ;;
        *)
            TARGET_TUPLE="i686-android-linux"
        ;;
    esac
fi

Edward Wang's avatar
Edward Wang committed
80 81 82 83 84 85 86
export TARGET_TUPLE
export PATH_HOST
export HAVE_ARM
export HAVE_X86
export HAVE_MIPS
export PLATFORM_SHORT_ARCH

87 88
# Add the NDK toolchain to the PATH, needed both for contribs and for building
# stub libraries
Rafaël Carré's avatar
Rafaël Carré committed
89
export PATH=${ANDROID_NDK}/toolchains/${PATH_HOST}-${GCCVER}/prebuilt/`uname|tr A-Z a-z`-x86/bin:${PATH}
90

Rafaël Carré's avatar
Rafaël Carré committed
91
# 1/ libvlc, libvlccore and its plugins
92
TESTED_HASH=04a376f95
93
if [ ! -d "vlc" ]; then
94
    echo "VLC source not found, cloning"
95
    git clone git://git.videolan.org/vlc.git vlc
Philipp Dreimann's avatar
Philipp Dreimann committed
96
    cd vlc
97
    git checkout -B android ${TESTED_HASH}
98
    echo "Applying the patches"
99
    git am -3 ../patches/*.patch
100 101 102 103 104
    if [ $? -ne 0 ]; then
        git am --abort
        echo "Applying the patches failed, aborting git-am"
        exit 1
    fi
105
else
106
    echo "VLC source found"
107
    cd vlc
108 109 110 111 112 113 114
    if ! git cat-file -e ${TESTED_HASH}; then
        cat << EOF
***
*** Error: Your vlc checkout does not contain the latest tested commit ***
***

Please update your source with something like:
Rémi Duraffort's avatar
Rémi Duraffort committed
115 116

cd vlc
117 118 119
git reset --hard origin
git pull origin master
git checkout -B android ${TESTED_HASH}
Sébastien Toque's avatar
Sébastien Toque committed
120
git am -3 ../patches/*
121 122 123 124 125 126 127

*** : This will delete any changes you made to the current branch ***

EOF
        exit 1
    fi
fi
Rémi Duraffort's avatar
Rémi Duraffort committed
128

129 130 131 132 133 134 135 136 137
if [ ${ANDROID_ABI} = "armeabi-v7a" ] ; then
    if test -z "${NO_NEON}" ; then
        EXTRA_CFLAGS="-mfpu=neon -mcpu=cortex-a8"
    else
        EXTRA_CFLAGS="-mfpu=vfpv3-d16 -mcpu=cortex-a9"
    fi
    EXTRA_CFLAGS="${EXTRA_CFLAGS} -mthumb -mfloat-abi=softfp"
elif [ ${ANDROID_ABI} = "armeabi" ] ; then
    export NO_NEON=1
Edward Wang's avatar
Edward Wang committed
138 139
    if [ -n "${NO_ARMV6}" ]; then
        EXTRA_CFLAGS="-march=armv5te -mtune=arm9tdmi -msoft-float"
140
    else
Edward Wang's avatar
Edward Wang committed
141 142 143 144 145
        if [ -n "${NO_FPU}" ]; then
            EXTRA_CFLAGS="-march=armv6j -mtune=arm1136j-s -msoft-float"
        else
            EXTRA_CFLAGS="-mfpu=vfp -mcpu=arm1136jf-s -mfloat-abi=softfp"
        fi
146
    fi
Edward Wang's avatar
Edward Wang committed
147 148
elif [ ${ANDROID_ABI} = "x86" ] ; then
    EXTRA_CFLAGS="-march=pentium -ffunction-sections -funwind-tables -frtti -fno-exceptions"
149 150 151
else
    echo "Unknown ABI. Die, die, die!"
    exit 2
152 153
fi

Rafaël Carré's avatar
Rafaël Carré committed
154 155 156
EXTRA_CFLAGS="${EXTRA_CFLAGS} -I${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++${CXXSTL}/include"
EXTRA_CFLAGS="${EXTRA_CFLAGS} -I${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++${CXXSTL}/libs/${ANDROID_ABI}/include"

157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175
echo "Building the contribs"
mkdir -p contrib/android
cd contrib/android
../bootstrap --host=${TARGET_TUPLE} --disable-disc --disable-sout --enable-small \
    --disable-sdl \
    --disable-SDL_image \
    --disable-fontconfig \
    --disable-zvbi \
    --disable-kate \
    --disable-caca \
    --disable-gettext \
    --disable-mpcdec \
    --disable-upnp \
    --disable-gme \
    --disable-tremor \
    --disable-vorbis \
    --disable-sidplay2 \
    --disable-samplerate \
    --disable-faad2 \
176
    --disable-harfbuzz \
177 178 179 180
    --enable-iconv

# TODO: mpeg2, theora

Rafaël Carré's avatar
Rafaël Carré committed
181 182
# Some libraries have arm assembly which won't build in thumb mode
# We append -marm to the CFLAGS of these libs to disable thumb mode
Rafaël Carré's avatar
Rafaël Carré committed
183
[ ${ANDROID_ABI} = "armeabi-v7a" ] && echo "NOTHUMB := -marm" >> config.mak
Rafaël Carré's avatar
Rafaël Carré committed
184

185
# Release or not?
186
if [ $# -ne 0 ] && [ "$1" == "release" ]; then
187
    OPTS=""
188 189
    EXTRA_CFLAGS="${EXTRA_CFLAGS} -DNDEBUG "
    RELEASEFLAG="RELEASE=1"
190 191 192 193
else
    OPTS="--enable-debug"
fi

194 195 196 197 198 199
MAKEFLAGS=
if which nproc >/dev/null
then
MAKEFLAGS=-j`nproc`
fi

200
echo "EXTRA_CFLAGS= -g ${EXTRA_CFLAGS}" >> config.mak
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
201
export VLC_EXTRA_CFLAGS="${EXTRA_CFLAGS}"
202

Rafaël Carré's avatar
Rafaël Carré committed
203
make fetch
204
make $MAKEFLAGS
Rémi Duraffort's avatar
Rémi Duraffort committed
205 206 207

cd ../.. && mkdir -p android && cd android

208
if test ! -s "../configure" ; then
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
209
    echo "Bootstraping"
Sébastien Toque's avatar
Sébastien Toque committed
210
    ../bootstrap
Rafaël Carré's avatar
Rafaël Carré committed
211
fi
Rémi Duraffort's avatar
Rémi Duraffort committed
212 213

echo "Configuring"
214
../../configure.sh $OPTS
Rémi Duraffort's avatar
Rémi Duraffort committed
215

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
216
echo "Building"
217
make $MAKEFLAGS
Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
218

Rafaël Carré's avatar
Rafaël Carré committed
219 220 221

# 2/ VLC android UI and specific code

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
222 223
echo "Building Android"
cd ../../
Rafaël Carré's avatar
Rafaël Carré committed
224

225
export ANDROID_SYS_HEADERS_GINGERBREAD=${PWD}/android-headers-gingerbread
226
export ANDROID_SYS_HEADERS_HC=${PWD}/android-headers-hc
227
export ANDROID_SYS_HEADERS_ICS=${PWD}/android-headers-ics
Rafaël Carré's avatar
Rafaël Carré committed
228 229

export ANDROID_LIBS=${PWD}/android-libs
230
export VLC_BUILD_DIR=vlc/android
Rafaël Carré's avatar
Rafaël Carré committed
231

Jean-Baptiste Kempf's avatar
Jean-Baptiste Kempf committed
232
make distclean
Rafaël Carré's avatar
Rafaël Carré committed
233
make TARGET_TUPLE=$TARGET_TUPLE PLATFORM_SHORT_ARCH=$PLATFORM_SHORT_ARCH CXXSTL=$CXXSTL $RELEASEFLAG